function[p, a, e, i, W, w, nu, w_true, u, lda] = rv2coe(r,v)
L = length(r(1,:));
mu = 398600.4425;
R = zeros(1,L);
V = zeros(1,L);
% h_vec = zeros(3,L);
% h = zeros(1,L);
n = zeros(1,L);
e_vec = zeros(3,L);
e = zeros(1,L);
a = zeros(1,L);
i = zeros(1,L);
W = zeros(1,L);
nu = zeros(1,L);
w = zeros(1,L);
w_true = zeros(1,L);
u = zeros(1,L);
lda = zeros(1,L);
p = zeros(1,L);
for j = 1 : L
R(j) = norm(r(1:3,j));
V(j) = norm(v(1:3,j));
h_vec = cross(r(1:3,j),v(1:3,j));
h = norm(h_vec);
n(1:3,j) = cross([0;0;1],h_vec);
e_vec(1:3,j) = ((V(j)^2 - mu/R(j))*r(1:3,j) - (r(1:3,j)'*v(1:3,j))*v(1:3,j))/mu;
e(j) = norm(e_vec(1:3,j));
    sp_e = (V(j)^2)/2 - mu/R(j);
    if e(j) == 1
        a(j) = inf;
        p(j) = (h^2)/mu;
    else
        a(j) = -mu/(2*sp_e);
        p(j) = a(j)*(1-e(j)^2);
    end
i(j) = acos(h_vec(3)/h);
W(j) = acos(n(1,j)/norm(n(1:3,j)));
    if n(2,j) < 0 
        W(j) = 2*pi - W(j);
    end
w(j) = acos((n(1:3,j)'*e_vec(1:3,j))/(norm(n(1:3,j))*e(j)));
    if e_vec(3,j) < 0
        w(j) = 2*pi - w(j);
    end
nu(j) = acos((e_vec(1:3,j)'*r(1:3,j))/(e(j)*R(j)));
    if r(1:3,j)'*v(1:3,j) < 0
        nu(j) = 2*pi - nu(j);
    end
w_true(j) = e_vec(1,j)/e(j);
    if e_vec(2,j)<0
        w_true(j) = 2*pi - w_true(j);
    end
u(j) = n(1:3,j)'*r(1:3,j);
    if r(3,j) <0
        u(j) = 2*pi - u(j);
    end
lda(j) = acos(r(1,j)/R(j));
    if r(2,j) < 0
        lda(j) = 2*pi - lda(j);
    end
end